## c-blosc2 2.17.1+ds

=== CMakeLists.txt ===
# Blosc - Blocked Shuffling and Compression Library
#
# Copyright (c) 2021  Blosc Development Team <blosc@blosc.org>
# https://blosc.org
# License: BSD 3-Clause (see LICENSE.txt)
#
# See LICENSE.txt for details about copyright and rights to use.

# CMake build system for Blosc
# ============================
#
# Available options:
#
#   BUILD_STATIC: default ON
#       build the static version of the Blosc library
#   BUILD_SHARED: default ON
#       build the shared library version of the Blosc library
#   BUILD_TESTS: default ON
#       build test programs and generates the "test" target
#   BUILD_FUZZERS: default ON
#       build fuzz test programs and generates the "fuzz" target
#   BUILD_BENCHMARKS: default ON
#       build the benchmark programs
#   BUILD_EXAMPLES: default ON
#       build the examples programs
#   BUILD_PLUGINS: default ON
#       build the plugins programs
#   BUILD_LITE: default OFF
#       build a lite version (only with BloscLZ and LZ4/LZ4HC) of the blosc library
#   DEACTIVATE_AVX2: default OFF
#       do not attempt to build with AVX2 instructions
#   DEACTIVATE_AVX512: default OFF
#       do not attempt to build with AVX512 instructions
#   DEACTIVATE_ZLIB: default OFF
#       do not include support for the Zlib library
#   DEACTIVATE_ZSTD: default OFF
#       do not include support for the Zstd library
#   WITH_ZLIB_OPTIM: default ON
#       set WITH_OPTIM when building Zlib library, setting OFF is useful for wasm32 targets
#   PREFER_EXTERNAL_LZ4: default OFF
#       when found, use the installed LZ4 libs instead of included
#       sources
#   PREFER_EXTERNAL_ZLIB: default OFF
#       when found, use the installed Zlib libs instead of included
#       MINIZ sources
#   PREFER_EXTERNAL_ZSTD: default OFF
#       when found, use the installed Zstd libs instead of included
#       sources
#   TEST_INCLUDE_BENCH_SHUFFLE_1: default ON
#       add a test that runs the benchmark program passing "shuffle" with 1
#       thread as second parameter
#   TEST_INCLUDE_BENCH_SHUFFLE_N: default ON
#       add a test that runs the benchmark program passing "shuffle" with all
#       threads as second parameter
#   TEST_INCLUDE_BENCH_BITSHUFFLE_1: default ON
#       add a test that runs the benchmark program passing "bitshuffle" with 1
#       thread as second parameter
#   TEST_INCLUDE_BENCH_BITSHUFFLE_N: default ON
#       add a test that runs the benchmark program passing "bitshuffle" with
#       all threads as second parameter
#   TEST_INCLUDE_BENCH_SUITE: default OFF
#       add a test that runs the benchmark program passing "suite"
#       as first parameter
#   TEST_INCLUDE_BENCH_HARDSUITE: default OFF
#       add a test that runs the benchmark program passing "hardsuite"
#       as first parameter
#   TEST_INCLUDE_BENCH_EXTREMESUITE: default OFF
#       add a test that runs the benchmark program passing "extremesuite"
#       as first parameter
#   TEST_INCLUDE_BENCH_DEBUGSUITE: default OFF
#       add a test that runs the benchmark program passing "debugsuite"
#       as first parameter
#
# Components:
#
#    LIB: includes blosc2.so
#    DEV: static includes blosc2.a and blosc2.h

if(NOT WIN32)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
endif()

cmake_minimum_required(VERSION 3.16.3)
if(${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.4)
  cmake_policy(SET CMP0063 NEW)
endif()
# The project can have ASM (zstd 1.5.2 is starting to use it)
project(blosc LANGUAGES C ASM)

# parse the full version numbers from blosc2.h
file(READ include/blosc2.h _blosc2_h_contents)
string(REGEX REPLACE ".*#define[ \t]+BLOSC2_VERSION_MAJOR[ \t]+([0-9]+).*"
    "\\1" BLOSC2_VERSION_MAJOR ${_blosc2_h_contents})
string(REGEX REPLACE ".*#define[ \t]+BLOSC2_VERSION_MINOR[ \t]+([0-9]+).*"
    "\\1" BLOSC2_VERSION_MINOR ${_blosc2_h_contents})
string(REGEX REPLACE ".*#define[ \t]+BLOSC2_VERSION_RELEASE[ \t]+([0-9]+).*"
    "\\1" BLOSC2_VERSION_PATCH ${_blosc2_h_contents})
string(REGEX REPLACE ".*#define[ \t]+BLOSC2_VERSION_STRING[ \t]+\"([-0-9A-Za-z.]+)\".*"
    "\\1" BLOSC2_VERSION_STRING ${_blosc2_h_contents})

message("Configuring for Blosc version: " ${BLOSC2_VERSION_STRING})

# options
option(BUILD_STATIC
    "Build a static version of the blosc library." ON)
option(BUILD_SHARED
    "Build a shared library version of the blosc library." ON)
option(BUILD_TESTS
    "Build test programs from the blosc compression library" ON)
option(BUILD_FUZZERS
    "Build fuzzer programs from the blosc compression library" ${BUILD_STATIC})
option(BUILD_BENCHMARKS
    "Build benchmark programs from the blosc compression library" ON)
option(BUILD_EXAMPLES
    "Build example programs from the blosc compression library" ON)
option(BUILD_PLUGINS
    "Build plugins programs from the blosc compression library" ON)
option(BUILD_LITE
    "Build a lite version (only with BloscLZ and LZ4/LZ4HC) of the blosc library." OFF)
option(DEACTIVATE_AVX2
    "Do not attempt to build with AVX2 instructions" OFF)
option(DEACTIVATE_AVX512
    "Do not attempt to build with AVX512 instructions" OFF)
option(DEACTIVATE_ZLIB
    "Do not include support for the Zlib library." OFF)
option(DEACTIVATE_ZSTD
    "Do not include support for the Zstd library." OFF)
option(DEACTIVATE_IPP
    "Do not include support for the Intel IPP library." ON)
option(PREFER_EXTERNAL_LZ4
    "Find and use external LZ4 library instead of included sources." OFF)
option(PREFER_EXTERNAL_ZLIB
    "Find and use external ZLIB library instead of included sources." OFF)
option(PREFER_EXTERNAL_ZSTD
    "Find and use external ZSTD library instead of included sources." OFF)
option(WITH_ZLIB_OPTIM
    "Set WITH_OPTIM for ZLIB, turning off is useful for compiling for wasm32 targets." ON)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

if(MINGW)
    # This gets us DLL resource information when compiling on MinGW.
    if(NOT CMAKE_RC_COMPILER)
        set(CMAKE_RC_COMPILER windres.exe)
    endif()
endif()

if(ENABLE_ASAN)
    message(STATUS "Enabling ASAN")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Os -fno-omit-frame-pointer -fsanitize=address")
endif()

if(BUILD_PLUGINS AND BUILD_LITE)
    message(FATAL_ERROR "Both plugins and lite Blosc versions can not be built at the same time.")
endif()

if(BUILD_LITE)
    set(DEACTIVATE_ZLIB ON)
    set(DEACTIVATE_ZSTD ON)
endif()

# Threads
set(CMAKE_THREAD_PREFER_PTHREAD TRUE) # pre 3.1
set(THREADS_PREFER_PTHREAD_FLAG TRUE) # CMake 3.1+
if(WIN32)
    # try to use the system library
    find_package(Threads)
else()
    find_package(Threads REQUIRED)
endif()
if(Threads_FOUND)
    set(HAVE_THREADS ON)
else()
    set(HAVE_THREADS OFF)
endif()

if(PREFER_EXTERNAL_LZ4)
    find_package(LZ4)
else()
    message(STATUS "Using LZ4 internal sources.")
endif()

if(NOT DEACTIVATE_ZLIB)
    if(PREFER_EXTERNAL_ZLIB)
        find_package(ZLIB_NG)
        if(ZLIB_NG_FOUND)
            set(HAVE_ZLIB_NG TRUE)
        else()
            find_package(ZLIB)
        endif()

        if(NOT (ZLIB_NG_FOUND OR ZLIB_FOUND))
            message(STATUS "No ZLIB found.  Using ZLIB-NG internal sources.")
        endif()
    endif()

    if(NOT (ZLIB_NG_FOUND OR ZLIB_FOUND))

        if (NOT WITH_ZLIB_OPTIM)
            set(WITH_OPTIM FALSE)
            set(WITH_RUNTIME_CPU_DETECTION FALSE)
        endif()
        message(STATUS "Using ZLIB-NG internal sources for ZLIB support.")
        set(HAVE_ZLIB_NG TRUE)
        add_definitions(-DZLIB_COMPAT)
        set(ZLIB_NG_DIR "zlib-ng-2.0.7")  # update to the actual included version
        set(ZLIB_COMPAT TRUE)
        set(SKIP_INSTALL_ALL TRUE)
        set(BUILD_SHARED_LIBS FALSE)
        set(ZLIB_ENABLE_TESTS OFF)
        add_subdirectory("internal-complibs/${ZLIB_NG_DIR}")

        file(COPY
                ${CMAKE_CURRENT_BINARY_DIR}/internal-complibs/${ZLIB_NG_DIR}/zconf.h
                DESTINATION ${CMAKE_CURRENT_SOURCE_DIR}/internal-complibs/${ZLIB_NG_DIR}/)
    endif()
    set(HAVE_ZLIB TRUE)
endif()


if(NOT DEACTIVATE_ZSTD)
    if(PREFER_EXTERNAL_ZSTD)
        find_package(ZSTD)
        if(NOT ZSTD_FOUND)
          message(STATUS "No ZSTD library found.  Using internal sources.")
        endif()
    else()
        message(STATUS "Using ZSTD internal sources.")
    endif()
    # HAVE_ZSTD will be set to true because even if the library is
    # not found, we will use the included sources for it
    set(HAVE_ZSTD TRUE)
endif()

if(NOT DEACTIVATE_IPP)
    find_package(IPP)
    if(IPP_FOUND)
        message(STATUS "Using IPP accelerated compression.")
        set(HAVE_IPP TRUE)
    else()
        message(STATUS "Not using IPP accelerated compression.")
        set(HAVE_IPP FALSE)
    endif()
endif()

if(BUILD_PLUGINS)
    set(HAVE_PLUGINS TRUE)
endif()

# create the config.h file
configure_file("${PROJECT_SOURCE_DIR}/blosc/config.h.in"
               "${PROJECT_SOURCE_DIR}/blosc/config.h")

# now make sure that you set the build directory on your "Include" path when compiling
include_directories("${PROJECT_BINARY_DIR}/blosc/")

# If the build type is not set, default to Release.
set(BLOSC_DEFAULT_BUILD_TYPE Release)
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "No build type specified. Defaulting to '${BLOSC_DEFAULT_BUILD_TYPE}'.")
    set(CMAKE_BUILD_TYPE ${BLOSC_DEFAULT_BUILD_TYPE} CACHE STRING
            "Choose the type of build." FORCE)

    # Set the possible values of build type for cmake-gui
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
            "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

# Propagate CMAKE_OSX_ARCHITECTURES env variable into CMAKE_SYSTEM_PROCESSOR
if(DEFINED ENV{CMAKE_OSX_ARCHITECTURES})
    if("$ENV{CMAKE_OSX_ARCHITECTURES}" STREQUAL "arm64")
        set(CMAKE_SYSTEM_PROCESSOR arm64)
    endif()
endif()

# Based on the target system's processor and the compiler being used,
# set build variables indicating which hardware features can be targeted
# by the compiler. Note we DO NOT check which hardware features are supported
# by this (the host) system, because we want to be able to support compiling
# for newer hardware on older machines as well as cross-compilation.
message(STATUS "Building for system processor ${CMAKE_SYSTEM_PROCESSOR}")
message(STATUS "Building for compiler ID ${CMAKE_C_COMPILER_ID}")
if(CMAKE_SYSTEM_PROCESSOR MATCHES i386|i686|x86_64|amd64|AMD64)
    if(CMAKE_C_COMPILER_ID MATCHES GNU)
        # We need C99 (GNU99 more exactly)
        SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
        set(COMPILER_SUPPORT_SSE2 TRUE)
        if(CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 4.7)
            set(COMPILER_SUPPORT_AVX2 TRUE)
        else()
            set(COMPILER_SUPPORT_AVX2 FALSE)
        endif()
        # GCC 10.3.2 (the version in manylinux_2014) seems to have issues supporting dynamic dispatching
        # of AVX512.  GCC 11.4 is the first minimal version that works well here.
        # That means that Linux wheels will have AVX512 disabled, but that's life.
        if(CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 11.4)
            set(COMPILER_SUPPORT_AVX512 TRUE)
        else()
            set(COMPILER_SUPPORT_AVX512 FALSE)
        endif()
    elseif(CMAKE_C_COMPILER_ID MATCHES Clang|AppleClang)
        set(COMPILER_SUPPORT_SSE2 TRUE)
        if(CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 3.2)
            set(COMPILER_SUPPORT_AVX2 TRUE)
        else()
            set(COMPILER_SUPPORT_AVX2 FALSE)
        endif()
        # Clang 13 is the minimum version that we know that works with AVX512 dynamic dispatch.
        # Perhaps lesser versions work too, better to err on the safe side.
        if(CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 13.0)
            set(COMPILER_SUPPORT_AVX512 TRUE)
        else()
            set(COMPILER_SUPPORT_AVX512 FALSE)
        endif()
    elseif(CMAKE_C_COMPILER_ID MATCHES Intel|IntelLLVM)
        # All Intel compilers since the introduction of AVX512 in 2016 should support it, so activate all SIMD flavors

=== bench/CMakeLists.txt ===
# Blosc - Blocked Shuffling and Compression Library
#
# Copyright (c) 2021  Blosc Development Team <blosc@blosc.org>
# https://blosc.org
# License: BSD 3-Clause (see LICENSE.txt)
#
# See LICENSE.txt for details about copyright and rights to use.

# sources for main bench
set(SOURCES b2bench.c)
# other benchmarks
set(SOURCES_DELTA delta_schunk.c)
set(SOURCES_TRUNC_PREC trunc_prec_schunk.c)
set(SOURCES_SUM_OPENMP sum_openmp.c)
set(SOURCES_ZERO_RUNLEN zero_runlen.c)
set(SOURCES_CFRAME create_frame.c)
set(SOURCES_SFRAME sframe_bench.c)

add_subdirectory(b2nd)

# targets
add_executable(b2bench ${SOURCES})
add_executable(delta_schunk ${SOURCES_DELTA})
add_executable(trunc_prec_schunk ${SOURCES_TRUNC_PREC})
add_executable(sum_openmp ${SOURCES_SUM_OPENMP})
add_executable(zero_runlen ${SOURCES_ZERO_RUNLEN})
add_executable(create_frame ${SOURCES_CFRAME})
add_executable(sframe_bench ${SOURCES_SFRAME})
if(UNIX AND NOT APPLE)
    # cmake is complaining about LINK_PRIVATE in original PR
    # and removing it does not seem to hurt, so be it.
    # target_link_libraries(b2bench LINK_PRIVATE rt)
    target_link_libraries(b2bench rt)
    target_link_libraries(delta_schunk rt)
    target_link_libraries(trunc_prec_schunk rt)
    target_link_libraries(sum_openmp rt)
    target_link_libraries(zero_runlen rt)
    target_link_libraries(create_frame rt)
    target_link_libraries(sframe_bench rt)
endif()
if(UNIX)
    if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
        # Avoid a warning when using gcc without -fopenmp
        target_compile_options(sum_openmp PRIVATE "-Wno-unknown-pragmas")
    endif()
endif()
target_link_libraries(b2bench blosc_testing)
target_link_libraries(delta_schunk blosc_testing)
target_link_libraries(trunc_prec_schunk blosc_testing)
target_link_libraries(sum_openmp blosc_testing)
target_link_libraries(zero_runlen blosc_testing)
target_link_libraries(create_frame blosc_testing)
target_link_libraries(sframe_bench blosc_testing)

# tests
if(BUILD_TESTS)

    # The commented tests below take too much time to complete
    option(TEST_INCLUDE_BENCH_SHUFFLE_1 "Include b2bench shuffle (1 thread) in the tests" ON)

    if(TEST_INCLUDE_BENCH_SHUFFLE_1)
        set(SHUFFLE_1_OPTS shuffle test 1)
        add_test(NAME test_blosclz_shuffle_1
            COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> blosclz ${SHUFFLE_1_OPTS})
        add_test(NAME test_lz4_shuffle_1
            COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> lz4 ${SHUFFLE_1_OPTS})
        # add_test(NAME test_lz4hc_shuffle_1
            # COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> lz4hc ${SHUFFLE_1_OPTS})
        if(HAVE_ZLIB)
            # add_test(NAME test_zlib_shuffle_1
                # COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> zlib ${SHUFFLE_1_OPTS})
        endif()
        if(HAVE_ZSTD)
            # add_test(NAME test_zstd_shuffle_1
                # COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> zstd ${SHUFFLE_1_OPTS})
        endif()
    endif()

    option(TEST_INCLUDE_BENCH_SHUFFLE_N "Include b2bench shuffle (multithread) in the tests" ON)
    if(TEST_INCLUDE_BENCH_SHUFFLE_N)
        set(SHUFFLE_N_OPTS shuffle test)
        add_test(NAME test_blosclz_shuffle_n
            COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> blosclz ${SHUFFLE_N_OPTS})
        add_test(NAME test_lz4_shuffle_n
            COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> lz4 ${SHUFFLE_N_OPTS})
        add_test(NAME test_lz4hc_shuffle_n
            COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> lz4hc ${SHUFFLE_N_OPTS})
        if(HAVE_ZLIB)
            add_test(NAME test_zlib_shuffle_n
                COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> zlib ${SHUFFLE_N_OPTS})
        endif()
        if(HAVE_ZSTD)
            add_test(NAME test_zstd_shuffle_n
                COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> zstd ${SHUFFLE_N_OPTS})
        endif()
    endif()

    option(TEST_INCLUDE_BENCH_BITSHUFFLE_1 "Include b2bench bitshuffle (1 thread) in the tests" ON)
    if(TEST_INCLUDE_BENCH_BITSHUFFLE_1)
        set(BITSHUFFLE_1_OPTS bitshuffle test 1)
        add_test(NAME test_blosclz_bitshuffle_1
            COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> blosclz ${BITSHUFFLE_1_OPTS})
        add_test(NAME test_lz4_bitshuffle_1
            COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> lz4 ${BITSHUFFLE_1_OPTS})
        # add_test(NAME test_lz4hc_bitshuffle_1
            # COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> lz4hc ${BITSHUFFLE_1_OPTS})
        if(HAVE_ZLIB)
            # add_test(NAME test_zlib_bitshuffle_1
                # COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> zlib ${BITSHUFFLE_1_OPTS})
        endif()
        if(HAVE_ZSTD)
            # add_test(NAME test_zstd_bitshuffle_1
                # COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> zstd ${BITSHUFFLE_1_OPTS})
        endif()
    endif()

    option(TEST_INCLUDE_BENCH_BITSHUFFLE_N "Include b2bench bitshuffle (multithread) in the tests" ON)
    if(TEST_INCLUDE_BENCH_BITSHUFFLE_N)
        set(BITSHUFFLE_N_OPTS bitshuffle test)
        add_test(NAME test_blosclz_bitshuffle_n
            COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> blosclz ${BITSHUFFLE_N_OPTS})
        add_test(NAME test_lz4_bitshuffle_n
            COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> lz4 ${BITSHUFFLE_N_OPTS})
        # add_test(NAME test_lz4hc_bitshuffle_n
            # COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> lz4hc ${BITSHUFFLE_N_OPTS})
        if(HAVE_ZLIB)
            # add_test(NAME test_zlib_bitshuffle_n
                # COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> zlib ${BITSHUFFLE_N_OPTS})
        endif()
        if(HAVE_ZSTD)
            # add_test(NAME test_zstd_bitshuffle_n
                # COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> zstd ${BITSHUFFLE_N_OPTS})
        endif()
    endif()

    option(TEST_INCLUDE_BENCH_SUITE "Include b2bench suite in the tests" OFF)
    if(TEST_INCLUDE_BENCH_SUITE)
        add_test(NAME test_hardsuite
            COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> blosclz shuffle suite)
    endif()

    option(TEST_INCLUDE_BENCH_DEBUGSUITE "Include b2bench debugsuite in the tests" OFF)
    if(TEST_INCLUDE_BENCH_DEBUGSUITE)
        add_test(NAME test_debugsuite
            COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:b2bench> blosclz shuffle debugsuite)
    endif()

    option(TEST_INCLUDE_BENCH_DELTA "Include delta bench in the tests" ON)
    if(TEST_INCLUDE_BENCH_DELTA)
        add_test(NAME test_bench_delta
            COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:delta_schunk>)
    endif()

    option(TEST_INCLUDE_BENCH_TRUNC_PREC "Include trunc bench in the tests" ON)
    if(TEST_INCLUDE_BENCH_TRUNC_PREC)
        add_test(NAME test_bench_trunc_prec
            COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:trunc_prec_schunk>)
    endif()

    option(TEST_INCLUDE_BENCH_SUM_OPENMP "Include sum_openmp in the tests" OFF)
    if(TEST_INCLUDE_BENCH_SUM_OPENMP)
        add_test(NAME test_bench_sum_openmp
            COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:sum_openmp>)
    endif()

    option(TEST_INCLUDE_BENCH_ZERO_RUNLEN "Include zero_runlen in the tests" ON)
    if(TEST_INCLUDE_BENCH_ZERO_RUNLEN)
        add_test(NAME test_bench_zero_runlen
            COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:zero_runlen>)
    endif()

endif()

=== plugins/CMakeLists.txt ===
# Blosc - Blocked Shuffling and Compression Library
#
# Copyright (c) 2021  Blosc Development Team <blosc@blosc.org>
# https://blosc.org
# License: BSD 3-Clause (see LICENSE.txt)
#
# See LICENSE.txt for details about copyright and rights to use.

add_subdirectory(codecs)
add_subdirectory(tuners)
add_subdirectory(filters)

set(SOURCES ${SOURCES} PARENT_SCOPE)

=== debian/changelog ===
c-blosc2 (2.17.1+ds-2) unstable; urgency=medium

  * debian/patches:
    - New 0002-glibc242-compat.patch (Closes: 1115531).

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Wed, 17 Sep 2025 21:34:48 +0000

c-blosc2 (2.17.1+ds-1) unstable; urgency=medium

  * New upstream release.
  * Standards version bumped to 4.7.2, no chenges.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 29 Mar 2025 11:18:00 +0000

=== debian/control ===
Source: c-blosc2
Priority: optional
Section: libs
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Antonio Valentino <antonio.valentino@tiscali.it>
Build-Depends: dpkg-dev (>= 1.22.5),
               debhelper-compat (= 13),
               cmake,
               dh-cmake-compat (= 1),
               dh-sequence-cmake,
               dh-sequence-sphinxdoc,
               dh-sequence-pkgkde-symbolshelper,
               liblz4-dev,
               pkg-kde-tools,
               zlib1g-dev,
               libzstd-dev,
               python3-breathe <!nodoc>,
               python3-pydata-sphinx-theme <!nodoc>,
               python3-sphinx <!nodoc>
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://blosc.org/
Vcs-Browser: https://salsa.debian.org/science-team/c-blosc2
Vcs-Git: https://salsa.debian.org/science-team/c-blosc2.git
Description: Fast, compressed, persistent binary data store library for C
 Blosc is a high performance compressor optimized for binary data. It has been
 designed to transmit data to the processor cache faster than the traditional,
 non-compressed, direct memory fetch approach via a memcpy() OS call. Blosc
 main goal is not just to reduce the size of large datasets on-disk or
 in-memory, but also to accelerate memory-bound computations.
 .
 C-Blosc2 is the new major version of C-Blosc, and tries hard to be backward
 compatible with both the C-Blosc1 API and its in-memory format. However, the
 reverse thing is generally not true for the format; buffers generated with
 C-Blosc2 are not format-compatible with C-Blosc1 (i.e. forward compatibility
 is not supported). In case you want to ensure full API compatibility with
 C-Blosc1 API, define the BLOSC1_COMPAT symbol.


Package: libblosc2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libblosc2-4 (= ${binary:Version}),
         ${misc:Depends}
Description: ${source:Synopsis} (development files)
 ${source:Extended-Description}
 .
 This package contains the development files required to build programs against
 Blosc2.

Package: libblosc2-4
X-Time64-Compat: libblosc2-4
Provides: ${t64:Provides}
Multi-Arch: same
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis}
 ${source:Extended-Description}

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,+bindnow
include /usr/share/dpkg/pkg-info.mk

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

UPSTREAM_VERSION = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')
include /usr/share/dpkg/architecture.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BINARY_DIR=debian/tmp \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DDEACTIVATE_AVX2=ON \
	-DDEACTIVATE_AVX512=ON \
	-DPREFER_EXTERNAL_LZ4=ON \
	-DPREFER_EXTERNAL_ZSTD=ON \
	-DPREFER_EXTERNAL_ZLIB=ON

override_dh_makeshlibs:
	dh_makeshlibs -- -v$(UPSTREAM_VERSION) -c0

override_dh_auto_test:
ifeq (,$(filter $(DEB_BUILD_ARCH),mips64el))
	dh_auto_test -- ARGS=--verbose --jobs=1
endif

override_dh_installchangelogs:
	dh_installchangelogs RELEASE_NOTES.md

## c-blosc2 2.22.0%2Bds

=== debian/changelog ===
c-blosc2 (2.22.0+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update d/copyright file.
  * debian/control:
    - Drop "Rules-Requires-Root: no".
  * debian/patches:
    - Drop 0002-glibc242-compat.patch, applied upstream.
    - Refresh remaining patches.
    - New 0002-Link-shared-libzstd.patch.
  * soversion bump. Package renamed from libblosc2-4 into libblosc2-6.
  * Update d/libblosc2-dev.docs.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sun, 07 Dec 2025 11:18:10 +0000

## c-blosc2 2.22.0+ds

=== debian/changelog ===
c-blosc2 (2.22.0+ds-1) unstable; urgency=medium

  * Upload to unstable.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 13 Dec 2025 09:39:29 +0000

## c-blosc2 2.23.0%2Bds

=== debian/changelog ===
c-blosc2 (2.23.0+ds-1~exp2) experimental; urgency=medium

  * debian/patches:
    - New 0004-Fix-pkgconfig-file.patch.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sun, 15 Feb 2026 21:57:42 +0100

c-blosc2 (2.23.0+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update d/copyright.
  * debian/rules:
    - Always prefer external libs.
  * debian/patches:
    - Refresh all patches.
    - New 0003-Fix-privacy-breaches.patch.
  * SOVERSION bump. Package renamed from libblosc2-6 into libblosc2-7.
  * Bump Standards-Version to 4.7.3, changes: priority.
  * Drop Priority: optional, default since dpkg 1.22.13.
  * New libblosc2-doc package.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 07 Feb 2026 20:17:49 +0000

## c-blosc2 2.23.0+ds

=== debian/changelog ===
c-blosc2 (2.23.0+ds-1) unstable; urgency=medium

  * Upload to unstable.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Wed, 18 Feb 2026 06:19:27 +0000

=== debian/rules ===
--- 
+++ 
@@ -22,8 +22,18 @@
 	-DDEACTIVATE_AVX2=ON \
 	-DDEACTIVATE_AVX512=ON \
 	-DPREFER_EXTERNAL_LZ4=ON \
+	-DPREFER_EXTERNAL_OPENZL=ON \
 	-DPREFER_EXTERNAL_ZSTD=ON \
 	-DPREFER_EXTERNAL_ZLIB=ON
+
+execute_after_dh_auto_build-indep:
+ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
+	cp -r images doc/images
+	env http_proxy='http://127.0.0.1:9/' https_proxy='https://127.0.0.1:9/' \
+	sphinx-build -N -E -T -b html doc doc/_build/html/
+	$(RM) -r doc/_build/html/.doctrees
+	$(RM) -r doc/_build/html/_static/vendor
+endif
 
 override_dh_makeshlibs:
 	dh_makeshlibs -- -v$(UPSTREAM_VERSION) -c0
